#!/usr/bin/env python

import roslib; roslib.load_manifest('continuous_ops_test_task')
import rospy
import optparse
import actionlib
from continuous_ops_msgs.msg import *

class Task():
    def __init__(self, ns):
        self.actionserver = actionlib.SimpleActionServer(ns, TaskAction, self.execute_cb)
        self.name = ns

    def execute_cb(self, goal):
        while not rospy.is_shutdown():
            rospy.loginfo('Testing task %s is running'%self.name)
            if self.actionserver.is_preempt_requested():
                if self.name == 'eitan_ns':
                    rospy.loginfo('Will refuse to preempt')
                else:
                    rospy.loginfo('Starting to preempt task')
                    rospy.sleep(5)
                    self.actionserver.set_preempted()
                    rospy.loginfo('Task Preempted')
            rospy.sleep(1.0)


def main():
    rospy.init_node('task_task')
    parser = optparse.OptionParser()
    (options, args) = parser.parse_args()
    ns = args[0]
    task = Task(ns)
    rospy.spin()    


if __name__ == '__main__':
    main()
