//how to debug = ros_debug();

function taskToBucket($item, run_id, running_task) {
  // image deletion function
  var remove_icon = '<a href="#" title="Remove Task From Queue" class="ui-icon ui-icon-close">Remove Task From Queue</a>';
  var $task_bucket = jQuery('#task_bucket');
  var $list = jQuery('ul',$task_bucket).length ? jQuery('ul',$task_bucket) : jQuery('<ul id="bucket" class="task_list ui-helper-reset"/>').sortable({
      update: function(event, ui){
        reorderTaskList();
      }
      }).appendTo($task_bucket);
  $item_clone = $item.clone();
  $item_clone.find('a.ui-icon-cart').remove();

  if(running_task == true){
    $item_clone.bind("click", checkForPreempt);
    $item_clone.removeClass('ui-widget-content');
    $item_clone.css({'background-color':'#6fd472', width: '103px'}).find('img').css({ width: '103px', height: '90px' });
  }
  else{
    $item_clone.bind("click", checkForRemove);
    $item_clone.css({ width: '103px'}).find('img').css({ width: '103px', height: '90px' });
  }

  $item_clone.prepend(remove_icon).attr('id', run_id).appendTo($list);
}

function updateTaskStatus(task) {
  setStatus(
    '<img src="' + gPump.hostport_prefix + '/task/image?id=' + task.task_id + '"  title="' + task.name + '" alt="' + task.name + '" width="206" height="180" />'
    + '<br><br><b>Current Task</b>: ' + task.name + '<br><b>Description</b>: ' + task.description
    );
}

function updateTaskList(tasks) {
  var task_list = jQuery('ul > li', jQuery("#task_bucket"));
  //we'll remove the previous tasks from the list
  for(i=0; i<task_list.length;i++){
    task_list[i].remove();
  }

  //we'll add items to the list in the order that they've come in
  for(i=0; i<tasks.tasks.length;i++){
    var $item = jQuery('#'+tasks.tasks[i].task_id);

    if(i == 0 && tasks.tasks[i].state == "Running"){
      updateTaskStatus(tasks.tasks[i]);
      taskToBucket($item, tasks.tasks[i].run_id, true);
    }
    else if(i == 0){
      setStatus("No running task.");
      taskToBucket($item, tasks.tasks[i].run_id, false);
    }
    else
      taskToBucket($item, tasks.tasks[i].run_id, false);
  }
}

function addTask($item){
  //first, we'll disable dragging on the task bucket
  jQuery("#task_bucket").droppable("option", "disabled", true);
  gPump.service_call2("task_manager/add_task", {'task_id': $item.attr('id')},
  function(tasks) {
    //add the task to the bucket
    taskToBucket($item, tasks.run_id, false);

    //the order of the list may have changed, we want to update it
    updateTaskList(tasks);
    jQuery("#task_bucket").droppable("option", "disabled", false);
  });
}

var checkAdd = function(ev){
  var $item = jQuery(this);
  var $target = jQuery(ev.target);

  if ($target.is('a.ui-icon-cart')) {
    addTask($item);
  } 
  return false;
}

function getAvailableTasks(tasks) {
  var $task_list = jQuery('#task_list');
  var current_list_items = jQuery('li', $task_list);

  //first, we want to remove any previous tasks
  for(var i = 0; i < current_list_items.length; ++i){
    current_list_items[i].remove();
  }

  //We want to add all tasks available to the task list
  for(var i = 0; i < tasks.tasks.length; ++i){
    //now, we'll insert the tasks with their images into the task list
    var list_item = jQuery('<li class="ui-widget-content ui-corner-tr" id="' + tasks.tasks[i].task_id + '"> <h5 class="ui-widget-header">' + tasks.tasks[i].name + '</h5><img src="' + gPump.hostport_prefix + '/task/image?id=' + tasks.tasks[i].task_id + '"  title="' + tasks.tasks[i].name + '" alt="' + tasks.tasks[i].name + '" width="206" height="180" /><a href="#" title="Add to list" class="ui-icon ui-icon-cart">Add to list</a></li>').draggable({
    cancel: 'a.ui-icon',// clicking an icon won't initiate dragging
    revert: 'invalid', // when not dropped, the item will revert back to its initial position
    containment: jQuery('#task-frame').length ? '#task-frame' : 'document', // stick to task-frame if present
    helper: 'clone',
    cursor: 'move'
    }).appendTo($task_list);
    list_item.bind("click", checkAdd);
  }
}

function reorderTaskList(){
  var task_list = jQuery('ul > li', jQuery("#task_bucket"));
  var task_order = new Array();
  for(i=0; i < task_list.length; i++){
    task_order[i] = task_list[i].id;
  }

  jQuery("#task_bucket").droppable("option", "disabled", true);
  gPump.service_call2("task_manager/reorder_tasks", {'run_id_list': task_order},
  function(tasks) {
    //the order of the list may have changed, we want to update it
    updateTaskList(tasks);
    jQuery("#task_bucket").droppable("option", "disabled", false);
  });
}

function removeFromBucket($item) {
  $item.fadeOut(function() {
    //remove the task from the bucket
    $item.find('a.ui-icon-close').parent().remove();
  });
}

// resolve the icons behavior with event delegation
var checkForRemove = function(ev) {
  var $item = jQuery(this);
  var $target = jQuery(ev.target);

  var disabled = jQuery("#task_bucket").droppable("option", "disabled");
  if ($target.is('a.ui-icon-close') && !disabled) {
    jQuery("#task_bucket").droppable("option", "disabled", true);
    removeFromBucket($item);
    gPump.service_call2("task_manager/remove_task", {'run_id': $item.attr('id')},
    function(tasks) {
      //the order of the list may have changed, we want to update it
      updateTaskList(tasks);
      jQuery("#task_bucket").droppable("option", "disabled", false);
    });
  }
};

var checkForPreempt = function(ev) {
  var $item = jQuery(this);
  var $target = jQuery(ev.target);

  var disabled = jQuery("#task_bucket").droppable("option", "disabled");
  if ($target.is('a.ui-icon-close') && !disabled) {
    dialogMessage("Confirm", "Are you sure you want to preempt the running task?",
      {
        buttons:
        {
          Ok: function() {
            gPump.service_call2("continuous_ops_executive/cancel_running_task", {'run_id': $item.attr('id')},
            function(tasks) {
              dialogMessage("Message", "The request to cancel the running task is being processed by the executive. This may take a few minutes, but you will see it reflected in your task list when it is complete.", 
                {
                  buttons:
                  {
                    Ok: function() {
                      jQuery(this).dialog('close');
                    }
                  }
                }
                );
            });
            jQuery(this).dialog('close');
          },
          Cancel: function(){
            jQuery(this).dialog('close');
          }
        }
      });
  }
};

jQuery(document).ready(function() {
  //we also want to get the tasks that are available
  gPump.service_call2("task_manager/get_available_tasks", {},
  function(tasks) {
    getAvailableTasks(tasks);
  });

  // there's the task_list and the task_bucket
  var $task_list = jQuery('#task_list'), $task_bucket = jQuery('#task_bucket');

  // let the task_bucket be droppable, accepting the task_list items
  $task_bucket.droppable({
    accept: '#task_list > li',
    activeClass: 'ui-state-highlight',
    drop: function(ev, ui) {
      addTask(ui.draggable);
    }
  });

  //and get the tasks that are currently running
  gPump.service_call2("task_manager/get_scheduled_tasks", {},
  function(tasks) {
    updateTaskList(tasks);
  });
});

var TaskUI = Class.create(Widget, {
  initialize: function($super, domobj) {
    $super(domobj);
    this.topics = ['/task_manager/available_tasks', '/task_manager/scheduled_tasks'];
    setStatus("Waiting to hear the robot's state...");
  },

  init: function() {
  },


  receive: function(topic, message) {
    if(topic == '/task_manager/available_tasks')
    {
      getAvailableTasks(message);
    }
    else if(topic == '/task_manager/scheduled_tasks')
    {
      updateTaskList(message);
    }
  },

});

function refreshAvailableTasks() {
  //we want to get the available tasks
  gPump.service_call2("task_manager/get_available_tasks", {},
  function(tasks) {
    getAvailableTasks(tasks);
  });
}

function setStatus(msg) {
  jQuery('#taskStatus').html(msg);
}

