#! /usr/bin/python
#***********************************************************
#* Software License Agreement (BSD License)
#*
#*  Copyright (c) 2009, Willow Garage, Inc.
#*  All rights reserved.
#*
#*  Redistribution and use in source and binary forms, with or without
#*  modification, are permitted provided that the following conditions
#*  are met:
#*
#*   * Redistributions of source code must retain the above copyright
#*     notice, this list of conditions and the following disclaimer.
#*   * Redistributions in binary form must reproduce the above
#*     copyright notice, this list of conditions and the following
#*     disclaimer in the documentation and/or other materials provided
#*     with the distribution.
#*   * Neither the name of Willow Garage, Inc. nor the names of its
#*     contributors may be used to endorse or promote products derived
#*     from this software without specific prior written permission.
#*
#*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
#*  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
#*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
#*  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
#*  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#*  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
#*  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#*  POSSIBILITY OF SUCH DAMAGE.
#* 
#* Author: Eitan Marder-Eppstein
#***********************************************************
import rospy
import rosweb
import threading
import Image
import cStringIO

from continuous_ops_msgs.msg import Tasks, Task

#_lock = threading.Lock()
_image_cache = {}

def task_cb(data):
    for task in data.tasks:
        print task.task_id
        print task.image_file
        im = Image.open(task.image_file)
        buf = cStringIO.StringIO()
        im.save(buf, format='JPEG')
        jpeg = buf.getvalue()
        _image_cache[task.task_id] = jpeg

def config_plugin(context):
    global task_sub
    task_sub = rospy.Subscriber("task_manager/available_tasks", Tasks, task_cb)
    context.register_handler('/task', task_server_handler)

def send_image(self, jpeg, cache_control='max-age=3600'):
    try:
        self.send_response(200)
        self.send_header('Cache-Control', cache_control)
        self.send_header('Content-Type', 'image/jpeg')
        self.send_header('Content-Length', str(len(jpeg)))
        self.end_headers()
        self.wfile.write(jpeg)
    except:
        pass


def task_server_handler(self, path, qdict):
    print "task"
    print path
    print qdict
    if path == '/task/image':
        print qdict['id'][0]
        jpeg = _image_cache[qdict['id'][0]]
        send_image(self, jpeg)
    return True

